"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var compositionApi = tslib_1.__importStar(require("@vue/composition-api"));
var BaseModel_1 = require("../core/BaseModel");
var method_1 = require("../core/utils/method");
var createReduxStore_1 = require("../core/utils/createReduxStore");
var Model = /** @class */ (function (_super) {
    tslib_1.__extends(Model, _super);
    function Model() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Model.prototype.switchReduxSelector = function () {
        return function (selector) {
            return compositionApi.computed(function () { return selector(createReduxStore_1.getStore().getState()); }).value;
        };
    };
    Model.prototype.patch = function (uri) {
        return this.serviceAction(uri, method_1.METHOD.patch);
    };
    return Model;
}(BaseModel_1.BaseModel));
exports.Model = Model;
