"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var vue_1 = tslib_1.__importDefault(require("vue"));
var composition_api_1 = tslib_1.__importStar(require("@vue/composition-api"));
var lodash_clonedeep_1 = tslib_1.__importDefault(require("lodash.clonedeep"));
var diff_1 = require("./diff");
var createReduxStore_1 = require("../core/utils/createReduxStore");
var useComposition = false;
createReduxStore_1.onStoreCreated(function (store) {
    var getCurrentState = store.getState;
    var originalState = getCurrentState();
    var observer = useComposition ? composition_api_1.reactive(lodash_clonedeep_1.default(originalState)) : vue_1.default.observable(lodash_clonedeep_1.default(originalState));
    store.getState = function () {
        return observer;
    };
    store.subscribe(function () {
        var currentState = getCurrentState();
        if (currentState !== originalState) {
            diff_1.applyPatch(originalState, currentState, observer);
            originalState = currentState;
        }
    });
});
exports.useCompositionApi = function (autoRegisterToVue) {
    if (autoRegisterToVue === void 0) { autoRegisterToVue = false; }
    useComposition = true;
    if (autoRegisterToVue) {
        vue_1.default.use(composition_api_1.default);
    }
};
exports.isUseCompositionApi = function () {
    return useComposition;
};
var createReduxStore_2 = require("../core/utils/createReduxStore");
exports.createReduxStore = createReduxStore_2.createReduxStore;
